---
title: Simple Usage
order: 1

---

本 Demo 演示一行文字的用法。

```jsx
import React, { useEffect, useState, Component } from 'react';
import ReactDOM from 'react-dom';
import { YwFilter } from '@ywfe/yw-design';
import 'antd/dist/antd.css';
const items = [
  {
    title: '标题',
    name: 'input',
    component: 'Input',
    type: 'string',
    props: {
      inset: true,
      colon: false,
    },
    componentProps: {
      placeholder: '请输入任务标题',
    },
  },
  {
    title: '标题',
    name: 'input2',
    component: 'Input',
    type: 'string',
    props: {
      inset: true,
      colon: false,
    },
    componentProps: {
      placeholder: '请输入任务标题',
    },
  },
  {
    title: '标题',
    name: 'input3',
    component: 'Input',
    type: 'string',
    props: {
      inset: true,
      colon: false,
    },
    componentProps: {
      placeholder: '请输入任务标题',
    },
  },
  {
    title: '类型',
    name: 'select',
    component: 'Select',
    type: 'string',
    props: {
      inset: true,
      colon: false,
    },
    enum: [
      { value: 1, label: 1 },
      { value: 2, label: 2 },
    ],
    componentProps: {},
  },
  {
    title: '发起人',
    name: 'person',
    component: 'Select',
    type: 'string',
    props: {
      inset: true,
      colon: false,
    },
    enum: [
      { value: 1, label: 1 },
      { value: 2, label: 2 },
    ],
    componentProps: {
      showSearch: true,
    },
  },
    {
    type: 'string',
    name: 'inputGroup',
    title: '',
    defaultValue:'createTime',
    enum: [
      { value: 'orderTime', label: '下单时间' },
      { value: 'createTime', label: '创建时间' },
    ],
    required:true,
    component: 'InputGroup',
    children:[
      {
       type: 'array',
        title: '',
        name: '[startDate,endDate]',
        required:true,
        component: 'DateRangePicker',
        defaultValue: ['2022-07-09', '2022-07-23'],
        componentProps: {
          ranges: ['昨天', '今天', '7天', '30天'],
          allowClear:true
        },
    }
    ]
  },
  {
    type: 'array',
    title: '提交审核时间',
    name: '[startDate1,endDate1]',
    component: 'DateRangePicker',
    defaultValue: ['2022-07-09', '2022-07-23'],
    props: {
      inset: true,
      colon: false,
    },
    componentProps: {
      ranges: ['昨天', '今天', '7天', '30天'],
    },
  },
  {
    type: 'array',
    title: '完成时间',
    name: '[startDate2,endDate2]',
    component: 'DateRangePicker',
    defaultValue: ['2022-07-09', '2022-07-23'],
    props: {
      inset: true,
      colon: false,
    },
    componentProps: {
      ranges: ['昨天', '今天', '7天', '30天'],
    },
  },
];

const App = () => {
    return (
      <div>
        <YwFilter items={items} itemWidth={340} onSubmit={(values)=>{console.log(values)}}/>
      </div>
    );
}

ReactDOM.render(<App />, mountNode);
```
