---
title: 自定义提交按钮
order: 5
---

```jsx
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import { YwJsonForm , LinkProvider, useLink, LinkBlock} from '@ywfe/yw-design';
import 'antd/dist/antd.css';
import { Button } from 'antd'
const items = [
  {
    title: '类型',
    name: 'source',
    component: 'Select',
    type: 'string',
    enum:[{value:true,label:'AAA'},{value:false,label:'BBB'}]
  },
];

const BtnCom = ()=> {
    const { dispatch } = useLink();
    return  (
      <Button type='primary' onClick={()=>{ 
                dispatch({
                    path: 'BtnCom',
                    type: 'onClick',
                    data:{
                        onSubmit:(value)=>{
                          console.log(value)
                        }
                    }
                })
            }}>
        自定义提交按钮
      </Button>
    )
}
const linkages = [{
  type:'command',
  source:'BtnCom',
  event:'onClick',
  actions:[{
    target:'YwJsonForm',
    action:'submit',
  }]
}]
const App =  ()=> {
    return (  
      <LinkProvider>
        <LinkBlock linkages={linkages}/>
        <BtnCom />
        <YwJsonForm items={items} buttons={[]}/>
      </LinkProvider>
    );
}

ReactDOM.render(<App />, mountNode);
```
