import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["maxRows", "itemWidth", "columnGap"],
    _excluded2 = ["maxRows", "maxColumns", "minColumns", "items", "itemWidth", "initialValues", "cache", "columnGap", "onSubmit", "onReset"];
import React, { useMemo, Fragment } from 'react';
import { Form, FormGrid, FormButtonGroup, Submit, Reset } from '@formily/antd';
import { useCollapseGrid } from "./useCollapseGrid";
import { observable } from '@formily/reactive';
import { observer, Observer, FormProvider } from '@formily/react';
import { createForm } from '@formily/core';
import styles from "./index.module.less";
import { YwJsonForm } from "../YwJsonForm";
import { DownOutlined, UpOutlined } from '@ant-design/icons';
var obs = observable({
  value: true
});
var QueryForm = observer(function (_ref) {
  var maxRows = _ref.maxRows,
      itemWidth = _ref.itemWidth,
      columnGap = _ref.columnGap,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useCollapseGrid = useCollapseGrid({
    maxRows: maxRows,
    itemWidth: itemWidth,
    columnGap: columnGap
  }),
      grid = _useCollapseGrid.grid,
      expanded = _useCollapseGrid.expanded,
      toggle = _useCollapseGrid.toggle,
      isLine = _useCollapseGrid.isLine,
      type = _useCollapseGrid.type;

  obs.value = isLine;

  var renderButtonGroup = function renderButtonGroup() {
    if (type === 'collapsible') {
      return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(FormButtonGroup, null, /*#__PURE__*/React.createElement("a", {
        style: {
          color: '#666',
          fontSize: '12px'
        },
        href: "",
        onClick: function onClick(e) {
          e.preventDefault();
          toggle();
        }
      }, !expanded ? /*#__PURE__*/React.createElement(React.Fragment, null, "\u5C55\u5F00", /*#__PURE__*/React.createElement(DownOutlined, {
        style: {
          marginLeft: '9px',
          color: '#999'
        }
      })) : /*#__PURE__*/React.createElement(React.Fragment, null, "\u6536\u8D77", /*#__PURE__*/React.createElement(UpOutlined, {
        style: {
          marginLeft: '9px',
          color: '#999'
        }
      })))));
    }
  };

  return /*#__PURE__*/React.createElement(Form, _extends({}, props, {
    feedbackLayout: "terse"
  }), /*#__PURE__*/React.createElement(FormGrid, {
    grid: grid
  }, props.children, /*#__PURE__*/React.createElement(FormGrid.GridColumn, {
    gridSpan: 24,
    style: {
      display: 'flex',
      justifyContent: 'center'
    }
  }, renderButtonGroup())));
});
export default function YwFilter(props) {
  var maxRows = props.maxRows,
      maxColumns = props.maxColumns,
      minColumns = props.minColumns,
      items = props.items,
      itemWidth = props.itemWidth,
      initialValues = props.initialValues,
      cache = props.cache,
      columnGap = props.columnGap,
      onSubmit = props.onSubmit,
      onReset = props.onReset,
      others = _objectWithoutPropertiesLoose(props, _excluded2);

  var _items = [{
    customComponent: QueryForm,
    componentProps: {
      minColumns: 3,
      maxColumns: 3,
      columnGap: columnGap,
      rowGap: 12,
      itemWidth: itemWidth,
      maxRows: maxRows
    },
    children: items
  }];
  var form = useMemo(function () {
    return createForm({
      initialValues: initialValues,
      effects: function effects() {}
    });
  }, []);
  return /*#__PURE__*/React.createElement("div", _extends({
    className: styles['yw-filter']
  }, others), /*#__PURE__*/React.createElement(FormProvider, {
    form: form
  }, /*#__PURE__*/React.createElement("div", {
    className: styles['form-container']
  }, /*#__PURE__*/React.createElement(YwJsonForm, {
    style: {
      flex: 1
    },
    buttons: [],
    layoutProps: {
      colon: false
    },
    items: _items,
    form: form
  }), /*#__PURE__*/React.createElement(Observer, null, function () {
    return /*#__PURE__*/React.createElement("div", {
      className: styles["group-btn-" + (!obs.value ? 'col' : 'line')]
    }, /*#__PURE__*/React.createElement(Submit, {
      onSubmit: onSubmit
    }, "\u67E5\u8BE2"), /*#__PURE__*/React.createElement(Reset, {
      onClick: onReset
    }, "\u91CD\u7F6E"));
  }))));
}
YwFilter.defaultProps = {
  maxRows: 2,
  maxColumns: 6,
  minColumns: 3,
  itemWidth: 328,
  columnGap: 20,
  items: [],
  initialValues: {},
  children: null,
  onSubmit: function onSubmit() {},
  cache: false,
  onReset: function onReset() {}
};