import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/extends";
var _excluded = ["sortable", "layoutProps", "hasAdd", "maxRow", "minRow", "arrayConfig", "editable"];
import React from 'react';
import { FormItem, Input, Select, NumberPicker, ArrayTable, Editable, FormLayout, Radio } from '@formily/antd';
import { FormProvider, createSchemaField, useField, useParentForm, observer } from '@formily/react';
var SchemaField = createSchemaField({
  components: {
    FormItem: FormItem,
    Editable: Editable,
    Input: Input,
    ArrayTable: ArrayTable,
    FormLayout: FormLayout,
    NumberPicker: NumberPicker,
    Select: Select,
    RadioGroup: Radio.Group
  }
});

var getArrayTableSchema = function getArrayTableSchema(_ref) {
  var _properties2;

  var sortable = _ref.sortable,
      minRow = _ref.minRow,
      name = _ref.name,
      arrayConfig = _ref.arrayConfig,
      dataSource = _ref.dataSource,
      editable = _ref.editable;
  var records = {};
  arrayConfig.forEach(function (item, idx) {
    var _properties;

    records["NO_FIELD_NAME_" + item.name + "_" + idx] = {
      type: 'void',
      'x-component': 'ArrayTable.Column',
      'x-component-props': {
        title: item.title,
        align: 'left'
      },
      properties: (_properties = {}, _properties[item.name] = _extends({}, item, {
        title: '',
        "default": '',
        'x-disabled': item.disabled,
        'x-decorator': item.editable ? 'Editable' : 'FormItem',
        'x-component': item.component,
        'x-validator': item.rules,
        'x-decorator-props': {},
        'x-component-props': _extends({}, item.componentProps, {
          required: true
        })
      }), _properties)
    };
  });
  return {
    type: 'void',
    properties: (_properties2 = {}, _properties2[name] = {
      type: 'array',
      "default": dataSource,
      'x-read-pretty': !editable,
      'x-decorator': 'FormItem',
      'x-component': 'ArrayTable',
      'x-component-props': {
        pagination: {
          pageSize: 10
        },
        align: 'center',
        bordered: false
      },
      items: {
        type: 'object',
        properties: _extends({
          column1: {
            type: 'void',
            'x-visible': sortable || false,
            'x-component': 'ArrayTable.Column',
            'x-component-props': {
              title: 'Sort',
              align: 'center'
            },
            properties: {
              sort: {
                type: 'void',
                'x-component': 'ArrayTable.SortHandle'
              }
            }
          }
        }, records, {
          column6: {
            type: 'void',
            'x-component': 'ArrayTable.Column',
            'x-component-props': {
              title: '',
              dataIndex: 'operations',
              width: 100,
              fixed: 'right'
            },
            properties: {
              item: {
                type: 'void',
                'x-component': 'FormItem',
                properties: {
                  remove: {
                    type: 'void',
                    'x-component': 'ArrayTable.Remove'
                  },
                  moveDown: {
                    type: 'void',
                    'x-component': 'ArrayTable.MoveDown'
                  },
                  moveUp: {
                    type: 'void',
                    'x-component': 'ArrayTable.MoveUp'
                  }
                }
              }
            }
          }
        })
      },
      properties: {
        add: {
          type: 'void',
          'x-component': 'ArrayTable.Addition',
          title: '增加',
          'x-visible': true,
          'x-reactions': {
            dependencies: [name],
            fulfill: {
              schema: {
                'x-visible': '{{ hasAdd && $deps[0]?.length < maxRow}}' // 任意层次属性都支持表达式

              }
            }
          }
        }
      }
    }, _properties2)
  };
};

var YArrayTable = function YArrayTable(_ref2) {
  var _arrayField$value, _arrayField$props;

  var sortable = _ref2.sortable,
      layoutProps = _ref2.layoutProps,
      _ref2$hasAdd = _ref2.hasAdd,
      hasAdd = _ref2$hasAdd === void 0 ? true : _ref2$hasAdd,
      _ref2$maxRow = _ref2.maxRow,
      maxRow = _ref2$maxRow === void 0 ? 3 : _ref2$maxRow,
      _ref2$minRow = _ref2.minRow,
      minRow = _ref2$minRow === void 0 ? 0 : _ref2$minRow,
      _ref2$arrayConfig = _ref2.arrayConfig,
      arrayConfig = _ref2$arrayConfig === void 0 ? [] : _ref2$arrayConfig,
      editable = _ref2.editable,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded);

  var arrayField = useField();
  var form = useParentForm();
  var dataSource = (arrayField === null || arrayField === void 0 ? void 0 : (_arrayField$value = arrayField.value) === null || _arrayField$value === void 0 ? void 0 : _arrayField$value.slice()) || [];
  var schema = getArrayTableSchema({
    sortable: sortable,
    arrayConfig: arrayConfig,
    minRow: minRow,
    name: arrayField === null || arrayField === void 0 ? void 0 : (_arrayField$props = arrayField.props) === null || _arrayField$props === void 0 ? void 0 : _arrayField$props.name,
    dataSource: dataSource,
    editable: editable
  });
  return /*#__PURE__*/React.createElement(FormProvider, {
    form: form
  }, /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema,
    scope: {
      maxRow: maxRow,
      hasAdd: hasAdd
    }
  }));
};

export default observer(YArrayTable);