import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["fetchOptions", "debounceTimeout"];
import React, { useRef, useMemo, useState } from 'react';
import { Select, Spin } from 'antd';
import debounce from 'lodash/debounce';
import { FormProvider, useField, useFieldSchema, useParentForm } from '@formily/react';

function DebounceSelect(_ref) {
  var fetchOptions = _ref.fetchOptions,
      _ref$debounceTimeout = _ref.debounceTimeout,
      debounceTimeout = _ref$debounceTimeout === void 0 ? 800 : _ref$debounceTimeout,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(false),
      fetching = _useState[0],
      setFetching = _useState[1];

  var _useState2 = useState([]),
      options = _useState2[0],
      setOptions = _useState2[1];

  var fetchRef = useRef(0);
  var debounceFetcher = useMemo(function () {
    var loadOptions = function loadOptions(value) {
      fetchRef.current += 1;
      var fetchId = fetchRef.current;
      setOptions([]);
      setFetching(true);
      fetchOptions(value).then(function (newOptions) {
        if (fetchId !== fetchRef.current) {
          // for fetch callback order
          return;
        }

        setOptions(newOptions);
        setFetching(false);
      });
    };

    return debounce(loadOptions, debounceTimeout);
  }, [fetchOptions, debounceTimeout]);
  return /*#__PURE__*/React.createElement(Select, _extends({
    labelInValue: true,
    filterOption: false,
    onSearch: debounceFetcher,
    showSearch: true,
    notFoundContent: fetching ? /*#__PURE__*/React.createElement(Spin, {
      size: "small"
    }) : null
  }, props, {
    options: options
  }));
}

var YSearchSelect = function YSearchSelect(props) {
  var field = useField();
  var form = useParentForm();
  var schema = useFieldSchema();
  var comProps = schema['x-component-props'] || {};

  var _useState3 = useState(field.initialValue || (comProps.mode ? [] : null)),
      value = _useState3[0],
      setValue = _useState3[1];

  return /*#__PURE__*/React.createElement(FormProvider, {
    form: form
  }, /*#__PURE__*/React.createElement(DebounceSelect, _extends({}, comProps, {
    value: value,
    fetchOptions: comProps.getDataSource,
    onChange: function onChange(newValue) {
      if (comProps.mode) {
        comProps.onChange && comProps.onChange(newValue);
        setValue(newValue);
        var v = newValue === null || newValue === void 0 ? void 0 : newValue.map(function (v) {
          return {
            label: v.label,
            value: v.value
          };
        });
        field.setValue(v);
      } else {
        setValue(newValue);
        field.setValue({
          label: newValue.label,
          value: newValue.value
        });
      }
    },
    style: {
      width: '100%'
    }
  })));
};

export default YSearchSelect;