import React from 'react';
import styles from "../index.module.less";
import { message, Tooltip } from 'antd';
import { CopyOutlined } from '@ant-design/icons';
import { CopyToClipboard } from 'react-copy-to-clipboard';
var preCssFix = 'yw-table-cell';
export var Copy = function Copy(_ref) {
  var text = _ref.text,
      _ref$onCopy = _ref.onCopy,
      _onCopy = _ref$onCopy === void 0 ? function () {} : _ref$onCopy;

  return /*#__PURE__*/React.createElement(CopyToClipboard, {
    text: text,
    onCopy: function onCopy() {
      message.success('复制成功');

      _onCopy();
    }
  }, /*#__PURE__*/React.createElement(CopyOutlined, {
    style: {
      color: '#1890ff',
      marginLeft: '4px'
    }
  }));
};
export var LongText2Ellipsis = function LongText2Ellipsis(_ref2) {
  var value = _ref2.value,
      _ref2$tooltip = _ref2.tooltip,
      tooltip = _ref2$tooltip === void 0 ? false : _ref2$tooltip,
      _ref2$isCopy = _ref2.isCopy,
      isCopy = _ref2$isCopy === void 0 ? false : _ref2$isCopy,
      _ref2$row = _ref2.row,
      row = _ref2$row === void 0 ? 2 : _ref2$row;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-long-text"]
  }, /*#__PURE__*/React.createElement("div", {
    className: styles["row-" + row]
  }, tooltip ? /*#__PURE__*/React.createElement(Tooltip, {
    placement: "topLeft",
    title: value
  }, value) : value), isCopy && /*#__PURE__*/React.createElement(Copy, {
    text: value
  })));
};

var Price = function Price(_ref3) {
  var price = _ref3.price;
  if (!price) return null;

  var PriceItem = function PriceItem(_ref4) {
    var value = _ref4.value;
    if (!value) return null;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
      className: styles.rmb
    }, "\xA5"), /*#__PURE__*/React.createElement("span", {
      className: styles.count
    }, value));
  };

  if (Array.isArray(price)) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: styles[preCssFix + "-detail-info-price"]
    }, /*#__PURE__*/React.createElement(PriceItem, {
      value: price[0]
    }), /*#__PURE__*/React.createElement("span", {
      className: styles.line
    }, "-"), /*#__PURE__*/React.createElement(PriceItem, {
      value: price[1]
    })));
  } else {
    return /*#__PURE__*/React.createElement("div", {
      className: styles[preCssFix + "-detail-info-price"]
    }, /*#__PURE__*/React.createElement(PriceItem, {
      value: price
    }));
  }
};

var ExtraInfo = function ExtraInfo(_ref5) {
  var items = _ref5.items;
  if (!items) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-row"]
  }, items.map(function (v) {
    return /*#__PURE__*/React.createElement("div", {
      className: styles.item
    }, v.label && /*#__PURE__*/React.createElement("span", null, v.label, "\uFF1A"), v.value && /*#__PURE__*/React.createElement("span", null, v.value, " ", v.isCopy && /*#__PURE__*/React.createElement(Copy, {
      text: v.value
    })));
  }));
};

var TagsInfo = function TagsInfo(_ref6) {
  var tags = _ref6.tags;
  if (!tags) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-tags"]
  }, tags === null || tags === void 0 ? void 0 : tags.map(function (v) {
    return /*#__PURE__*/React.createElement("span", {
      className: styles.tag,
      key: v.value
    }, v.value);
  }));
};

var GoodTitle = function GoodTitle(_ref7) {
  var _ref7$title = _ref7.title,
      title = _ref7$title === void 0 ? {} : _ref7$title;
  var value = title.value,
      linkUrl = title.linkUrl,
      icon = title.icon;
  if (!value) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.title
  }, linkUrl ? /*#__PURE__*/React.createElement("a", {
    href: linkUrl,
    target: "_blank"
  }, /*#__PURE__*/React.createElement(LongText2Ellipsis, {
    value: value
  })) : /*#__PURE__*/React.createElement(LongText2Ellipsis, {
    value: value
  }));
};

var TitleToolTip = function TitleToolTip(_ref8) {
  var _ref8$tooltip = _ref8.tooltip,
      tooltip = _ref8$tooltip === void 0 ? {} : _ref8$tooltip;
  var value = tooltip.value,
      label = tooltip.label,
      isCopy = tooltip.isCopy;
  if (!value) return null;
  var title = /*#__PURE__*/React.createElement("div", null, label && /*#__PURE__*/React.createElement("span", null, label, "\uFF1A"), value && /*#__PURE__*/React.createElement("span", null, value), isCopy && /*#__PURE__*/React.createElement(Copy, {
    text: value
  }));
  return /*#__PURE__*/React.createElement(Tooltip, {
    placement: "top",
    title: title
  }, /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-tooltip"]
  }, /*#__PURE__*/React.createElement("span", {
    className: styles['icon-id']
  }, "ID")));
};

export var DetailInfo = function DetailInfo(_ref9) {
  var _ref9$value = _ref9.value,
      value = _ref9$value === void 0 ? {} : _ref9$value,
      record = _ref9.record;
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info"]
  }, /*#__PURE__*/React.createElement("div", null, value.imgUrl && /*#__PURE__*/React.createElement("img", {
    src: value.imgUrl,
    alt: "",
    className: styles[preCssFix + "-detail-info-img"]
  })), /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-text"]
  }, /*#__PURE__*/React.createElement(GoodTitle, {
    title: value.title
  }), /*#__PURE__*/React.createElement(ExtraInfo, {
    items: value.items
  }), /*#__PURE__*/React.createElement(Price, {
    price: value.price
  }), /*#__PURE__*/React.createElement(TagsInfo, {
    tags: value.tags
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(TitleToolTip, {
    tooltip: value.tooltip
  })));
};