import * as React from 'react';
import styles from "../index.module.less";
import Operates from "./operates";
import { Tag } from 'antd';
import { COLORMAP, isFunction } from "../../../utils";
var preCssFix = 'yw-table-cell';

var MultipleCol = function MultipleCol(_ref) {
  var value = _ref.value;
  return value.map(function (_ref2, idx) {
    var label = _ref2.label,
        value = _ref2.value,
        children = _ref2.children;
    return /*#__PURE__*/React.createElement("div", {
      key: idx,
      style: {
        color: '#666',
        marginTop: idx !== 0 ? '12px' : 0
      }
    }, /*#__PURE__*/React.createElement("span", null, label || '-'), "\uFF1A", /*#__PURE__*/React.createElement("span", null, children || value || '-'));
  });
};

var Person = function Person(_ref3) {
  var value = _ref3.value,
      _onClick = _ref3.onClick;
  var canClick = isFunction(_onClick);
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-person"]
  }, /*#__PURE__*/React.createElement("img", {
    className: styles.avatar,
    src: value.avatar,
    alt: "",
    onClick: function onClick() {
      _onClick(value);
    },
    style: {
      cursor: canClick ? 'pointer' : ''
    }
  }), /*#__PURE__*/React.createElement("span", null, value.name));
};

var Time = function Time(_ref4) {
  var value = _ref4.value;
  return /*#__PURE__*/React.createElement("div", null, value || '/');
};

var Status = function Status(_ref5) {
  var value = _ref5.value,
      _ref5$dataSource = _ref5.dataSource,
      dataSource = _ref5$dataSource === void 0 ? [] : _ref5$dataSource;
  var target = dataSource.find(function (v) {
    return v.value === value;
  }) || {};
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-status"]
  }, /*#__PURE__*/React.createElement("span", {
    className: styles.dot,
    style: {
      background: COLORMAP[target.color] || target.color
    }
  }), target.value);
};

var Tags = function Tags(_ref6) {
  var _ref6$value = _ref6.value,
      value = _ref6$value === void 0 ? [] : _ref6$value,
      _ref6$dataSource = _ref6.dataSource,
      dataSource = _ref6$dataSource === void 0 ? [] : _ref6$dataSource;

  var _v = Array.isArray(value) ? value : [value];

  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-tag"]
  }, _v === null || _v === void 0 ? void 0 : _v.map(function (v) {
    var target = dataSource.find(function (data) {
      return data.value === v;
    }) || {};
    return /*#__PURE__*/React.createElement(Tag, {
      key: target.value,
      color: target.color
    }, target.value);
  }));
};

export { Person, Time, Status, Tags, MultipleCol, Operates };