import _extends from "@babel/runtime/helpers/extends";
import * as React from 'react';
import styles from "../index.module.less";
import { Button, Modal } from 'antd';
import { FormDialog } from '@formily/antd';
import { useForm } from '@formily/react';
import { YwJsonForm } from "../../YwJsonForm";
import { isVisible, isDisabled, isFunction } from "../../../utils";
var confirm = Modal.confirm;
var preCssFix = 'yw-table-cell';

var showDeleteConfirm = function showDeleteConfirm(props, data, reload) {
  confirm(_extends({
    okText: '确定',
    okType: 'primary',
    cancelText: '取消'
  }, props, {
    content: isFunction(props.content) ? props.content(data) : props.content,
    title: isFunction(props.title) ? props.title(data) : props.title || '提示',
    onOk: function onOk() {
      props.onOk(data, reload);
    },
    onCancel: function onCancel() {
      console.log('Cancel');
    }
  }));
};

var showFormDialog = function showFormDialog(_ref, data, reload) {
  var jsonFormProps = _ref.jsonFormProps,
      modalProps = _ref.modalProps,
      onOpen = _ref.onOpen,
      onConfirm = _ref.onConfirm,
      onCancel = _ref.onCancel;
  FormDialog(_extends({
    okText: '确认',
    okType: 'primary',
    cancelText: '取消'
  }, modalProps), function () {
    var form = useForm();
    return /*#__PURE__*/React.createElement(YwJsonForm, _extends({
      buttons: [],
      form: form
    }, jsonFormProps, {
      layoutProps: _extends({
        inset: true
      }, jsonFormProps.layoutProps)
    }));
  }).forOpen(function (payload, next) {
    if (isFunction(onOpen)) {
      onOpen(data).then(function (initialValues) {
        next({
          initialValues: initialValues
        });
      });
    } else {
      next({
        initialValues: data
      });
    }
  }).forConfirm(function (payload, next) {
    if (isFunction(onConfirm)) {
      onConfirm(payload.values).then(function () {
        next(payload);
      });
    } else {
      next(payload);
    }
  }).forCancel(function (payload, next) {
    next(payload);
  }).open().then(reload());
};

var handleOperatesClick = function handleOperatesClick(component, componentProps, data, reload) {
  switch (component) {
    case 'ConfirmModal':
      showDeleteConfirm(componentProps, data, reload);
      break;

    case 'FormDialog':
      showFormDialog(componentProps, data, reload);
      break;

    default:
      break;
  }
};

var Operates = function Operates(_ref2) {
  var _ref2$value = _ref2.value,
      value = _ref2$value === void 0 ? [] : _ref2$value,
      record = _ref2.record,
      reload = _ref2.reload;
  var showValues = value.filter(function (_ref3) {
    var _ref3$visible = _ref3.visible,
        visible = _ref3$visible === void 0 ? true : _ref3$visible;
    return isVisible(visible, record);
  });
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-operates"]
  }, showValues.map(function (v, i) {
    return /*#__PURE__*/React.createElement("span", {
      key: i,
      style: {
        marginRight: '8px'
      }
    }, /*#__PURE__*/React.createElement(Button, {
      type: "link",
      danger: v.type === 'danger',
      href: v.href,
      target: v.target,
      disabled: isDisabled(v.disabled, record),
      onClick: function onClick(e) {
        if (v.component) {
          handleOperatesClick(v.component, v.componentProps, record, reload);
        } else {
          v.onClick && v.onClick(e, record, reload);
        }
      },
      style: {
        padding: '4px 0'
      }
    }, v.btnText));
  }));
};

export default Operates;