"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = YwFilter;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("@formily/antd");

var _useCollapseGrid2 = require("./useCollapseGrid");

var _reactive = require("@formily/reactive");

var _react2 = require("@formily/react");

var _core = require("@formily/core");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _YwJsonForm = require("../YwJsonForm");

var _icons = require("@ant-design/icons");

var _excluded = ["maxRows", "itemWidth", "columnGap"],
    _excluded2 = ["maxRows", "maxColumns", "minColumns", "items", "itemWidth", "initialValues", "cache", "columnGap", "onSubmit", "onReset"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var obs = (0, _reactive.observable)({
  value: true
});
var QueryForm = (0, _react2.observer)(function (_ref) {
  var maxRows = _ref.maxRows,
      itemWidth = _ref.itemWidth,
      columnGap = _ref.columnGap,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  var _useCollapseGrid = (0, _useCollapseGrid2.useCollapseGrid)({
    maxRows: maxRows,
    itemWidth: itemWidth,
    columnGap: columnGap
  }),
      grid = _useCollapseGrid.grid,
      expanded = _useCollapseGrid.expanded,
      toggle = _useCollapseGrid.toggle,
      isLine = _useCollapseGrid.isLine,
      type = _useCollapseGrid.type;

  obs.value = isLine;

  var renderButtonGroup = function renderButtonGroup() {
    if (type === 'collapsible') {
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_antd.FormButtonGroup, null, /*#__PURE__*/_react["default"].createElement("a", {
        style: {
          color: '#666',
          fontSize: '12px'
        },
        href: "",
        onClick: function onClick(e) {
          e.preventDefault();
          toggle();
        }
      }, !expanded ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, "\u5C55\u5F00", /*#__PURE__*/_react["default"].createElement(_icons.DownOutlined, {
        style: {
          marginLeft: '9px',
          color: '#999'
        }
      })) : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, "\u6536\u8D77", /*#__PURE__*/_react["default"].createElement(_icons.UpOutlined, {
        style: {
          marginLeft: '9px',
          color: '#999'
        }
      })))));
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_antd.Form, (0, _extends2["default"])({}, props, {
    feedbackLayout: "terse"
  }), /*#__PURE__*/_react["default"].createElement(_antd.FormGrid, {
    grid: grid
  }, props.children, /*#__PURE__*/_react["default"].createElement(_antd.FormGrid.GridColumn, {
    gridSpan: 24,
    style: {
      display: 'flex',
      justifyContent: 'center'
    }
  }, renderButtonGroup())));
});

function YwFilter(props) {
  var maxRows = props.maxRows,
      maxColumns = props.maxColumns,
      minColumns = props.minColumns,
      items = props.items,
      itemWidth = props.itemWidth,
      initialValues = props.initialValues,
      cache = props.cache,
      columnGap = props.columnGap,
      onSubmit = props.onSubmit,
      onReset = props.onReset,
      others = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded2);
  var _items = [{
    customComponent: QueryForm,
    componentProps: {
      minColumns: 3,
      maxColumns: 3,
      columnGap: columnGap,
      rowGap: 12,
      itemWidth: itemWidth,
      maxRows: maxRows
    },
    children: items
  }];
  var form = (0, _react.useMemo)(function () {
    return (0, _core.createForm)({
      initialValues: initialValues,
      effects: function effects() {}
    });
  }, []);
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: _indexModule["default"]['yw-filter']
  }, others), /*#__PURE__*/_react["default"].createElement(_react2.FormProvider, {
    form: form
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['form-container']
  }, /*#__PURE__*/_react["default"].createElement(_YwJsonForm.YwJsonForm, {
    style: {
      flex: 1
    },
    buttons: [],
    layoutProps: {
      colon: false
    },
    items: _items,
    form: form
  }), /*#__PURE__*/_react["default"].createElement(_react2.Observer, null, function () {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]["group-btn-" + (!obs.value ? 'col' : 'line')]
    }, /*#__PURE__*/_react["default"].createElement(_antd.Submit, {
      onSubmit: onSubmit
    }, "\u67E5\u8BE2"), /*#__PURE__*/_react["default"].createElement(_antd.Reset, {
      onClick: onReset
    }, "\u91CD\u7F6E"));
  }))));
}

YwFilter.defaultProps = {
  maxRows: 2,
  maxColumns: 6,
  minColumns: 3,
  itemWidth: 328,
  columnGap: 20,
  items: [],
  initialValues: {},
  children: null,
  onSubmit: function onSubmit() {},
  cache: false,
  onReset: function onReset() {}
};