"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _antd = require("@formily/antd");

var _YDatePicker = require("./YDatePicker");

var _react2 = require("@formily/react");

var RadioGroup = _antd.Radio.Group;
var CheckboxGroup = _antd.Checkbox.Group;
var TextArea = _antd.Input.TextArea;
var SchemaField = (0, _react2.createSchemaField)({
  components: {
    FormItem: _antd.FormItem,
    Input: _antd.Input,
    Select: _antd.Select,
    RadioGroup: RadioGroup,
    TextArea: TextArea,
    Switch: _antd.Switch,
    CheckboxGroup: CheckboxGroup,
    NumberPicker: _antd.NumberPicker,
    Cascader: _antd.Cascader,
    WeekRangePicker: _YDatePicker.WeekRangePicker,
    DateRangePicker: _YDatePicker.DateRangePicker,
    MonthRangePicker: _YDatePicker.MonthRangePicker,
    DateTimeRangePicker: _YDatePicker.DateTimeRangePicker,
    MonthPicker: _YDatePicker.MonthPicker,
    WeekPicker: _YDatePicker.WeekPicker,
    DatePicker: _YDatePicker.DatePicker,
    DateTimePicker: _YDatePicker.DateTimePicker
  }
});

var YInputGroup = function YInputGroup(props) {
  var field = (0, _react2.useField)();
  var form = (0, _react2.useParentForm)();
  var schema = (0, _react2.useFieldSchema)();
  return /*#__PURE__*/_react["default"].createElement(_react2.FormProvider, {
    form: form
  }, /*#__PURE__*/_react["default"].createElement(_antd.Input.Group, {
    compact: true
  }, /*#__PURE__*/_react["default"].createElement(_antd.Select, {
    defaultValue: field.initialValue,
    disabled: field.disabled,
    options: field.dataSource
  }), /*#__PURE__*/_react["default"].createElement(SchemaField, {
    schema: schema
  })));
};

var _default = YInputGroup;
exports["default"] = _default;