"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _react2 = require("@formily/react");

var _excluded = ["fetchOptions", "debounceTimeout"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function DebounceSelect(_ref) {
  var fetchOptions = _ref.fetchOptions,
      _ref$debounceTimeout = _ref.debounceTimeout,
      debounceTimeout = _ref$debounceTimeout === void 0 ? 800 : _ref$debounceTimeout,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      fetching = _useState[0],
      setFetching = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      options = _useState2[0],
      setOptions = _useState2[1];

  var fetchRef = (0, _react.useRef)(0);
  var debounceFetcher = (0, _react.useMemo)(function () {
    var loadOptions = function loadOptions(value) {
      fetchRef.current += 1;
      var fetchId = fetchRef.current;
      setOptions([]);
      setFetching(true);
      fetchOptions(value).then(function (newOptions) {
        if (fetchId !== fetchRef.current) {
          // for fetch callback order
          return;
        }

        setOptions(newOptions);
        setFetching(false);
      });
    };

    return (0, _debounce["default"])(loadOptions, debounceTimeout);
  }, [fetchOptions, debounceTimeout]);
  return /*#__PURE__*/_react["default"].createElement(_antd.Select, (0, _extends2["default"])({
    labelInValue: true,
    filterOption: false,
    onSearch: debounceFetcher,
    showSearch: true,
    notFoundContent: fetching ? /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
      size: "small"
    }) : null
  }, props, {
    options: options
  }));
}

var YSearchSelect = function YSearchSelect(props) {
  var field = (0, _react2.useField)();
  var form = (0, _react2.useParentForm)();
  var schema = (0, _react2.useFieldSchema)();
  var comProps = schema['x-component-props'] || {};

  var _useState3 = (0, _react.useState)(field.initialValue || (comProps.mode ? [] : null)),
      value = _useState3[0],
      setValue = _useState3[1];

  return /*#__PURE__*/_react["default"].createElement(_react2.FormProvider, {
    form: form
  }, /*#__PURE__*/_react["default"].createElement(DebounceSelect, (0, _extends2["default"])({}, comProps, {
    value: value,
    fetchOptions: comProps.getDataSource,
    onChange: function onChange(newValue) {
      if (comProps.mode) {
        comProps.onChange && comProps.onChange(newValue);
        setValue(newValue);
        var v = newValue === null || newValue === void 0 ? void 0 : newValue.map(function (v) {
          return {
            label: v.label,
            value: v.value
          };
        });
        field.setValue(v);
      } else {
        setValue(newValue);
        field.setValue({
          label: newValue.label,
          value: newValue.value
        });
      }
    },
    style: {
      width: '100%'
    }
  })));
};

var _default = YSearchSelect;
exports["default"] = _default;