"use strict";

exports.__esModule = true;
exports.useAsyncDataSource = void 0;

var _reactive = require("@formily/reactive");

var useAsyncDataSource = function useAsyncDataSource(dataSource) {
  return function (field) {
    // console.log('keyword', keyword);
    field.loading = true;
    var service = dataSource[field.props.name];
    service(field).then(_reactive.action.bound(function (data) {
      field.dataSource = data;
      field.loading = false;
    }));
  };
};

exports.useAsyncDataSource = useAsyncDataSource;