"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.YwJsonForm = YwJsonForm;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _core = require("@formily/core");

var _antd = require("@formily/antd");

var _react2 = require("@formily/react");

var _YwTitle = _interopRequireDefault(require("../YwTitle"));

var _hook = require("./hook");

var _ywLinkage = require("@ywfe/yw-linkage");

var _YDatePicker = require("./YDatePicker");

var _YInputGroup = _interopRequireDefault(require("./YInputGroup"));

var _YArrayTable = _interopRequireDefault(require("./YArrayTable"));

var _YSearchSelect = _interopRequireDefault(require("./YSearchSelect"));

var _rules = require("./rules");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _excluded = ["CustomComponent"],
    _excluded2 = ["buttons", "onCreate", "onSubmit", "editable", "disabled", "size", "layoutProps", "buttonsProps", "items", "initialValues", "linkActions", "valueChangeforLink"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TextArea = _antd.Input.TextArea;
var RadioGroup = _antd.Radio.Group;
var CheckboxGroup = _antd.Checkbox.Group; // let customComponent: any[] = [];

var dataSource = {};
(0, _core.registerValidateFormats)(_rules.FORMATS);
(0, _core.registerValidateRules)(_rules.RULES);

var customComponent = function customComponent(props) {
  var field = (0, _react2.useField)();
  var schema = (0, _react2.useFieldSchema)();

  var _ref = schema['x-component-props'] || {},
      CustomComponent = _ref.CustomComponent,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  return CustomComponent && /*#__PURE__*/_react["default"].createElement(CustomComponent, (0, _extends2["default"])({}, rest, {
    field: field
  }));
};

var SchemaField = (0, _react2.createSchemaField)({
  components: {
    Input: _antd.Input,
    FormItem: _antd.FormItem,
    FormLayout: _antd.FormLayout,
    Select: _antd.Select,
    RadioGroup: RadioGroup,
    TextArea: TextArea,
    Switch: _antd.Switch,
    CheckboxGroup: CheckboxGroup,
    NumberPicker: _antd.NumberPicker,
    FormGrid: _antd.FormGrid,
    Cascader: _antd.Cascader,
    WeekRangePicker: _YDatePicker.WeekRangePicker,
    DateRangePicker: _YDatePicker.DateRangePicker,
    MonthRangePicker: _YDatePicker.MonthRangePicker,
    MonthPicker: _YDatePicker.MonthPicker,
    WeekPicker: _YDatePicker.WeekPicker,
    DatePicker: _YDatePicker.DatePicker,
    DateTimeRangePicker: _YDatePicker.DateTimeRangePicker,
    DateTimePicker: _YDatePicker.DateTimePicker,
    InputGroup: _YInputGroup["default"],
    ArrayTable: _YArrayTable["default"],
    SearchSelect: _YSearchSelect["default"] // ...customComponent,

  }
});

var formatSchema = function formatSchema(item) {
  if (item === void 0) {
    item = {};
  }

  // if (item.customComponent) {
  //   customComponent = [...customComponent, item.customComponent];
  // }
  if (item.getDataSource) {
    dataSource[item.name] = item.getDataSource;
  }

  return (0, _extends2["default"])({
    type: item.type || 'void',
    title: item.title,
    description: item.description,
    "default": item.defaultValue,
    readOnly: item.readOnly,
    "enum": item["enum"],
    required: item.required,
    'x-validator': item.rules,
    'x-decorator': item.decorator || 'FormItem',
    'x-decorator-props': (0, _extends2["default"])({}, item.props, {
      getDataSource: item.getDataSource
    })
  }, item.getDataSource ? {
    'x-reactions': ['{{useAsyncDataSource(dataSource)}}']
  } : {}, {
    'x-component': item.customComponent ? customComponent : item.component,
    'x-component-props': (0, _extends2["default"])({}, item.componentProps, item.customComponent ? {
      CustomComponent: item.customComponent
    } : {}),
    'x-visible': item.visible,
    'x-disabled': item.disabled,
    'x-read-pretty': item.preview
  });
};

function YwJsonForm(props) {
  var buttons = props.buttons,
      onCreate = props.onCreate,
      onSubmit = props.onSubmit,
      editable = props.editable,
      disabled = props.disabled,
      size = props.size,
      layoutProps = props.layoutProps,
      buttonsProps = props.buttonsProps,
      items = props.items,
      initialValues = props.initialValues,
      linkActions = props.linkActions,
      valueChangeforLink = props.valueChangeforLink,
      others = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded2);

  var _useLink = (0, _ywLinkage.useLink)(),
      when = _useLink.when,
      run = _useLink.run,
      registerActions = _useLink.registerActions,
      dispatch = _useLink.dispatch;

  var form = props.form || (0, _react.useMemo)(function () {
    return (0, _core.createForm)({
      disabled: disabled,
      editable: editable,
      effects: function effects(form) {
        (0, _core.onFormInit)(function () {
          onCreate(form);
        });
        (0, _core.onFormValuesChange)(function (form) {
          valueChangeforLink && valueChangeforLink(form.values, dispatch); // console.log('change', jsonLogic.apply({ '==': [form.values.source, true]) );
          // onValueChange('change', form.values);
        });
      }
    });
  }, []);

  var FormGroup = function FormGroup(props) {
    return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_YwTitle["default"], {
      size: props.size,
      text: props.text
    }), /*#__PURE__*/_react["default"].createElement(_antd.FormLayout, (0, _extends2["default"])({}, layoutProps, {
      size: size,
      style: {
        marginTop: '20px'
      }
    }), props.children));
  };

  var getItemsSchema = function getItemsSchema() {
    var formatItem = function formatItem(nodeList) {
      if (nodeList.length === 0) {
        return null;
      }

      var res = {};
      nodeList.forEach(function (item, idx) {
        if (item.component === 'FormGroup') {
          // 分组标题
          res["NO_FIELD_NAME_" + idx] = (0, _extends2["default"])({
            type: 'void',
            'x-component': FormGroup,
            'x-decorator': 'FormItem',
            'x-visible': item.visible,
            'x-component-props': {
              size: size === 'small' ? 's' : 'm',
              text: item.title
            }
          }, item.children ? formatItem(item.children) : {});
        } else if (item.component === 'FormGrid') {
          // grid
          res["NO_FIELD_NAME_" + idx] = (0, _extends2["default"])({}, formatSchema(item), item.children ? formatItem(item.children) : {});
        } else if (item.component === 'ArrayTable') {
          // ArrayTable
          res[item.name] = (0, _extends2["default"])({}, formatSchema(item), {
            type: 'array',
            'x-component-props': (0, _extends2["default"])({}, item.componentProps, {
              layoutProps: layoutProps,
              arrayConfig: item.children
            })
          });
        } else {
          res[item.name] = (0, _extends2["default"])({}, formatSchema(item), item.children ? formatItem(item.children) : {});
        }
      });
      return {
        properties: res
      };
    };

    return formatItem(items || []);
  };

  var renderButtons = function renderButtons() {
    return buttons !== null && buttons !== void 0 && buttons.length ? /*#__PURE__*/_react["default"].createElement(_antd.FormButtonGroup.FormItem, null, buttons === null || buttons === void 0 ? void 0 : buttons.map(function (btn) {
      var _component = {
        submit: /*#__PURE__*/_react["default"].createElement(_antd.Submit, {
          key: "submit",
          onSubmit: onSubmit,
          size: size
        }, "\u63D0\u4EA4"),
        reset: /*#__PURE__*/_react["default"].createElement(_antd.Reset, {
          key: "reset",
          size: size
        }, "\u91CD\u7F6E"),
        button: btn.children
      };
      return _component[btn.htmlType];
    })) : null;
  };

  (0, _react.useEffect)(function () {
    // linkActions && registerActions(linkActions);
    registerActions([{
      path: 'YwJsonForm',
      type: 'submit',
      execute: function execute(_ref2) {
        var _ref2$onSubmit = _ref2.onSubmit,
            onSubmit = _ref2$onSubmit === void 0 ? function () {} : _ref2$onSubmit;
        form.submit().then(function (value) {
          onSubmit(value);
        });
      }
    }]);
  });
  (0, _react.useEffect)(function () {
    initialValues && form.setValues(initialValues);
  }, [initialValues]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-json-form'],
    style: props.style
  }, /*#__PURE__*/_react["default"].createElement(_react2.FormProvider, {
    form: form
  }, /*#__PURE__*/_react["default"].createElement(_ywLinkage.LinkProvider, null, /*#__PURE__*/_react["default"].createElement(_antd.FormLayout, (0, _extends2["default"])({}, layoutProps, {
    size: size
  }), /*#__PURE__*/_react["default"].createElement(SchemaField, {
    schema: getItemsSchema(),
    scope: {
      useAsyncDataSource: _hook.useAsyncDataSource,
      dataSource: dataSource
    }
  }), buttonsProps.sticky ? /*#__PURE__*/_react["default"].createElement(_antd.FormButtonGroup.Sticky, {
    align: buttonsProps.align
  }, renderButtons()) : renderButtons()))));
} // let form = null;
// function YwJsonFormWithLink(props: YwJsonFormProps) {
//   const { linkages, ...rest } = props;
//   const _linkages = linkages.map((rule) => {
//     return {
//       type: 'command',
//       source: 'YwJsonForm',
//       event: rule.type === 'value' ? 'onChange' : 'state',
//       condition: rule.conditions,
//       actions: [
//         {
//           target: 'YwJsonForm',
//           action: rule.type,
//           params: {
//             conditions: rule.conditions,
//             targetState: rule.targetState,
//             targetValue: rule.targetValue,
//             target: rule.target,
//           },
//         },
//       ],
//     };
//   });
//   return (
//     <LinkProvider>
//       <LinkBlock linkages={_linkages} />
//       <YwJsonForm
//         onCreate={(_form) => {
//           form = _form;
//         }}
//         {...rest}
//         linkActions={[
//           {
//             path: 'YwJsonForm',
//             type: 'value',
//             execute: ({ conditions, targetValue, targetState, target }) => {
//               if (jsonLogic.apply(conditions, form.values)) {
//                 targetValue !== undefined && form.setValuesIn(target, targetValue);
//                 targetState !== undefined && form.setFieldState(target, targetState);
//               }
//             },
//           },
//           {
//             path: 'YwJsonForm',
//             type: 'dataSource',
//             execute: ({ conditions, targetValue, targetState = {}, target }) => {
//               const { dataSource } = targetState;
//               if (jsonLogic.apply(conditions, form.values)) {
//                 form.setValuesIn(target, '');
//                 dataSource !== undefined && form.setFieldState(target, { dataSource });
//               }
//             },
//           },
//           {
//             path: 'YwJsonForm',
//             type: 'visible',
//             execute: ({ conditions, target }) => {
//               if (jsonLogic.apply(conditions, form.values)) {
//                 form.setFieldState(target, { visible: false });
//               } else {
//                 form.setFieldState(target, { visible: true });
//               }
//             },
//           },
//           {
//             path: 'YwJsonForm',
//             type: 'disabled',
//             execute: ({ conditions, target }) => {
//               if (jsonLogic.apply(conditions, form.values)) {
//                 form.setFieldState(target, { disabled: true });
//               } else {
//                 form.setFieldState(target, { disabled: false });
//               }
//             },
//           },
//         ]}
//         valueChangeforLink={(values, dispatch) => {
//           linkages.forEach(({ conditions = {}, ...rule }) => {
//             if (rule.type === 'value') {
//               dispatch({
//                 path: 'YwJsonForm',
//                 type: 'onChange',
//               });
//             } else {
//               dispatch({
//                 path: 'YwJsonForm',
//                 type: 'state',
//               });
//             }
//           });
//         }}
//       />
//     </LinkProvider>
//   );
// }


YwJsonForm.defaultProps = {
  form: null,
  layoutProps: {
    // labelAlign: 'right',
    labelCol: 6,
    wrapperCol: 10 // inset: true,
    // inline: true,
    // layout:['vertical', 'horizontal','inline'],

  },
  linkages: [],
  buttons: [{
    htmlType: 'submit'
  }, {
    htmlType: 'reset'
  }],
  buttonsProps: {},
  onSubmit: function onSubmit(form) {
    console.log('submit', form);
  },
  onCreate: function onCreate(form) {// console.log('表单初始化', form)
    // form.setInitialValues({ input: 123333 })
  } // onValueChange: (data, form) => {
  // form.setInitialValues({ input: 123333 })
  // },

}; // YwJsonForm.displayName = 'YwJsonForm';