"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var React = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("../index.module.less"));

var _antd = require("antd");

var _antd2 = require("@formily/antd");

var _react2 = require("@formily/react");

var _YwJsonForm = require("../../YwJsonForm");

var _utils = require("../../../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var confirm = _antd.Modal.confirm;
var preCssFix = 'yw-table-cell';

var showDeleteConfirm = function showDeleteConfirm(props, data, reload) {
  confirm((0, _extends2["default"])({
    okText: '确定',
    okType: 'primary',
    cancelText: '取消'
  }, props, {
    content: (0, _utils.isFunction)(props.content) ? props.content(data) : props.content,
    title: (0, _utils.isFunction)(props.title) ? props.title(data) : props.title || '提示',
    onOk: function onOk() {
      props.onOk(data, reload);
    },
    onCancel: function onCancel() {
      console.log('Cancel');
    }
  }));
};

var showFormDialog = function showFormDialog(_ref, data, reload) {
  var jsonFormProps = _ref.jsonFormProps,
      modalProps = _ref.modalProps,
      onOpen = _ref.onOpen,
      onConfirm = _ref.onConfirm,
      onCancel = _ref.onCancel;
  (0, _antd2.FormDialog)((0, _extends2["default"])({
    okText: '确认',
    okType: 'primary',
    cancelText: '取消'
  }, modalProps), function () {
    var form = (0, _react2.useForm)();
    return /*#__PURE__*/React.createElement(_YwJsonForm.YwJsonForm, (0, _extends2["default"])({
      buttons: [],
      form: form
    }, jsonFormProps, {
      layoutProps: (0, _extends2["default"])({
        inset: true
      }, jsonFormProps.layoutProps)
    }));
  }).forOpen(function (payload, next) {
    if ((0, _utils.isFunction)(onOpen)) {
      onOpen(data).then(function (initialValues) {
        next({
          initialValues: initialValues
        });
      });
    } else {
      next({
        initialValues: data
      });
    }
  }).forConfirm(function (payload, next) {
    if ((0, _utils.isFunction)(onConfirm)) {
      onConfirm(payload.values).then(function () {
        next(payload);
      });
    } else {
      next(payload);
    }
  }).forCancel(function (payload, next) {
    next(payload);
  }).open().then(reload());
};

var handleOperatesClick = function handleOperatesClick(component, componentProps, data, reload) {
  switch (component) {
    case 'ConfirmModal':
      showDeleteConfirm(componentProps, data, reload);
      break;

    case 'FormDialog':
      showFormDialog(componentProps, data, reload);
      break;

    default:
      break;
  }
};

var Operates = function Operates(_ref2) {
  var _ref2$value = _ref2.value,
      value = _ref2$value === void 0 ? [] : _ref2$value,
      record = _ref2.record,
      reload = _ref2.reload;
  var showValues = value.filter(function (_ref3) {
    var _ref3$visible = _ref3.visible,
        visible = _ref3$visible === void 0 ? true : _ref3$visible;
    return (0, _utils.isVisible)(visible, record);
  });
  return /*#__PURE__*/React.createElement("div", {
    className: _indexModule["default"][preCssFix + "-operates"]
  }, showValues.map(function (v, i) {
    return /*#__PURE__*/React.createElement("span", {
      key: i,
      style: {
        marginRight: '8px'
      }
    }, /*#__PURE__*/React.createElement(_antd.Button, {
      type: "link",
      danger: v.type === 'danger',
      href: v.href,
      target: v.target,
      disabled: (0, _utils.isDisabled)(v.disabled, record),
      onClick: function onClick(e) {
        if (v.component) {
          handleOperatesClick(v.component, v.componentProps, record, reload);
        } else {
          v.onClick && v.onClick(e, record, reload);
        }
      },
      style: {
        padding: '4px 0'
      }
    }, v.btnText));
  }));
};

var _default = Operates;
exports["default"] = _default;