"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _index = require("./components/index");

var _detailInfo = require("./components/detailInfo");

var _usePagination2 = _interopRequireDefault(require("./usePagination"));

var _index2 = require("../../utils/index");

var _excluded = ["component", "componentProps", "formatValues"],
    _excluded2 = ["visible"],
    _excluded3 = ["visible"],
    _excluded4 = ["columns", "buttons", "getTableData", "filterProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var registerCom = {
  MultipleCol: _index.MultipleCol,
  Time: _index.Time,
  Person: _index.Person,
  Status: _index.Status,
  Operates: _index.Operates,
  Tags: _index.Tags,
  DetailInfo: _detailInfo.DetailInfo,
  LongText2Ellipsis: _detailInfo.LongText2Ellipsis
};

var formatColumns = function formatColumns(_columns, _ref) {
  if (_columns === void 0) {
    _columns = [];
  }

  var reload = _ref.reload;
  return _columns.map(function (_ref2) {
    var _ref2$component = _ref2.component,
        component = _ref2$component === void 0 ? '' : _ref2$component,
        componentProps = _ref2.componentProps,
        _ref2$formatValues = _ref2.formatValues,
        formatValues = _ref2$formatValues === void 0 ? null : _ref2$formatValues,
        item = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded);
    if (!component) return item;
    return (0, _extends2["default"])({}, item, {
      render: function render(data, record, index) {
        var Component = registerCom[component] || null;

        if (formatValues) {
          var value = formatValues(data, record, index);
          return /*#__PURE__*/_react["default"].createElement(Component, (0, _extends2["default"])({
            value: value
          }, componentProps, {
            record: record,
            key: item.dataIndex
          }));
        }

        return /*#__PURE__*/_react["default"].createElement(Component, (0, _extends2["default"])({
          value: data
        }, componentProps, {
          record: record,
          reload: reload,
          key: item.dataIndex
        }));
      }
    });
  });
};

var formatBatchBtn = function formatBatchBtn(buttons, _ref3) {
  if (buttons === void 0) {
    buttons = [];
  }

  var hasSelect = _ref3.hasSelect,
      selectedRowKeys = _ref3.selectedRowKeys,
      selectedData = _ref3.selectedData,
      reload = _ref3.reload;
  return buttons.filter(function (v) {
    return v.type === 'batch' && (0, _index2.isVisible)(v.visible, null);
  }).map(function (_ref4, i) {
    var _ref4$visible = _ref4.visible,
        visible = _ref4$visible === void 0 ? true : _ref4$visible,
        v = (0, _objectWithoutPropertiesLoose2["default"])(_ref4, _excluded2);
    return visible && /*#__PURE__*/_react["default"].createElement(_antd.Button, {
      key: i,
      disabled: !hasSelect || (0, _index2.isDisabled)(v.disabled, null),
      onClick: function onClick() {
        v.onClick(selectedRowKeys, selectedData, reload);
      }
    }, v.btnText);
  });
};

var formatActionBtn = function formatActionBtn(buttons, _ref5) {
  if (buttons === void 0) {
    buttons = [];
  }

  var reload = _ref5.reload;
  return buttons.filter(function (v) {
    return v.type !== 'batch' && (0, _index2.isVisible)(v.visible, null);
  }).map(function (_ref6, i) {
    var _ref6$visible = _ref6.visible,
        visible = _ref6$visible === void 0 ? true : _ref6$visible,
        v = (0, _objectWithoutPropertiesLoose2["default"])(_ref6, _excluded3);

    if (v.btnType === 'dropdown') {
      var _v$dataSource;

      var menu = /*#__PURE__*/_react["default"].createElement(_antd.Menu, {
        onClick: function onClick(data) {
          v.onClick(data, reload);
        }
      }, (_v$dataSource = v.dataSource) === null || _v$dataSource === void 0 ? void 0 : _v$dataSource.map(function (_ref7) {
        var key = _ref7.key,
            label = _ref7.label;
        return /*#__PURE__*/_react["default"].createElement(_antd.Menu.Item, {
          key: key
        }, label);
      }));

      return visible && /*#__PURE__*/_react["default"].createElement(_antd.Dropdown, {
        overlay: menu
      }, /*#__PURE__*/_react["default"].createElement(_antd.Button, {
        disabled: (0, _index2.isDisabled)(v.disabled, null)
      }, v.btnText, " ", /*#__PURE__*/_react["default"].createElement(_icons.DownOutlined, null)));
    }

    return visible && /*#__PURE__*/_react["default"].createElement(_antd.Button, {
      key: i,
      type: v.btnType || 'primary',
      disabled: v.disabled,
      onClick: function onClick() {
        v.onClick(reload);
      }
    }, v.children || v.btnText);
  });
};

function YwTable(props) {
  var _props$rowSelection;

  var columns = props.columns,
      buttons = props.buttons,
      getTableData = props.getTableData,
      filterProps = props.filterProps,
      others = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded4);

  var _useState = (0, _react.useState)(((_props$rowSelection = props.rowSelection) === null || _props$rowSelection === void 0 ? void 0 : _props$rowSelection.selectedRowKeys) || []),
      selectedRowKeys = _useState[0],
      setSelectedRowKeys = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      selectedData = _useState2[0],
      setSelectedData = _useState2[1];

  var rowSelection = props.rowSelection ? (0, _extends2["default"])({}, props.rowSelection, {
    selectedRowKeys: selectedRowKeys,
    onChange: function onChange(newSelectedRowKeys, data) {
      setSelectedRowKeys(newSelectedRowKeys);
      setSelectedData(data);
    }
  }) : null;
  var hasSelect = (0, _react.useMemo)(function () {
    return !!(selectedRowKeys.length > 0);
  }, [selectedRowKeys]);

  var _usePagination = (0, _usePagination2["default"])(function (_ref8, params) {
    var pageIndex = _ref8.pageIndex,
        pageSize = _ref8.pageSize;
    return getTableData((0, _extends2["default"])({
      pageIndex: pageIndex,
      pageSize: pageSize
    }, params));
  }, {
    manual: true
  }),
      data = _usePagination.data,
      loading = _usePagination.loading,
      pagination = _usePagination.pagination,
      run = _usePagination.run,
      params = _usePagination.params;

  (0, _react.useEffect)(function () {
    var _params$;

    run({
      pageIndex: 1,
      pageSize: ((_params$ = params[0]) === null || _params$ === void 0 ? void 0 : _params$.pageSize) || 20
    }, filterProps);
  }, [filterProps]);

  var reload = function reload() {
    setSelectedRowKeys([]);
    setSelectedData([]);
    run(params[0] || {}, params[1] || {});
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-table'] + " " + _indexModule["default"]['yw-table-multiple'],
    style: props.style
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]["yw-table-btns"]
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"].batch
  }, rowSelection && /*#__PURE__*/_react["default"].createElement("span", {
    className: _indexModule["default"].total
  }, "\u5171\u9009\u4E2D ", selectedRowKeys.length, " \u6761 "), formatBatchBtn(buttons, {
    hasSelect: hasSelect,
    selectedRowKeys: selectedRowKeys,
    selectedData: selectedData,
    reload: reload
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"].action
  }, formatActionBtn(buttons, {
    reload: reload
  }))), /*#__PURE__*/_react["default"].createElement(_antd.Table, (0, _extends2["default"])({}, others, {
    columns: formatColumns(columns, {
      reload: reload
    }),
    dataSource: (data === null || data === void 0 ? void 0 : data.list) || [],
    loading: loading,
    pagination: (0, _extends2["default"])({}, pagination, props.pagination),
    rowSelection: rowSelection
  })));
}

YwTable.defaultProps = {
  multiple: true,
  stickyHeader: false,
  composite: true,
  pagination: {},
  buttons: [],
  rowSelection: null,
  columns: [],
  filterProps: {},
  getTableData: function getTableData() {}
};
var _default = YwTable;
exports["default"] = _default;