"use strict";

exports.__esModule = true;
exports.isVisible = exports.isFunction = exports.isDisabled = exports.COLORMAP = void 0;

var isFunction = function isFunction(value) {
  return typeof value === 'function';
};

exports.isFunction = isFunction;
var COLORMAP = {
  primary: '#1890FF',
  success: '#23CBB7',
  error: '#F15A5A',
  warning: '#FAAD14',
  other: '#9C7AFF',
  "default": '#666'
};
exports.COLORMAP = COLORMAP;

var isVisible = function isVisible(visible, data) {
  if (visible === void 0) {
    visible = true;
  }

  return isFunction(visible) ? visible(data) : visible;
};

exports.isVisible = isVisible;

var isDisabled = function isDisabled(disabled, data) {
  return isFunction(disabled) ? disabled(data) : disabled;
};

exports.isDisabled = isDisabled;